unit Zylinder;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, dglOpenGL;

type

  { TKolben }

  TKolben = class(TObject)
  private
    fmaxHub: single;
  public
    constructor Create(maxHub: single);
    procedure Draw(HubPos: single);
  end;

implementation

{ TKolben }

constructor TKolben.Create(maxHub: single);
begin
  inherited Create;
  fmaxHub := maxHub;
end;

procedure TKolben.Draw(HubPos: single);
const
  h = 100;
var
  KolbenW,
  p: single;

begin
  KolbenW := fmaxHub / 100;

  glBegin(GL_QUADS);
  glColor3f(0.1, 0.1, 0.1);
  glVertex3f(0, -h, 0.1);
  glVertex3f(0, h, 0.1);

  glColor3f(0.2, 0.2, 0.2);
  glVertex3f(fmaxHub, h, 0.1);
  glVertex3f(fmaxHub, -h, 0.1);
  glEnd();

  p:=HubPos;

  glBegin(GL_QUADS);
  glColor3f(0.7, 0.7, 0.7);
  glVertex3f(-KolbenW + p, -h, 0.0);
  glVertex3f(-KolbenW + p, h, 0.0);

  glColor3f(0.8, 0.8, 0.8);
  glVertex3f(KolbenW + p, h, 0.0);
  glVertex3f(KolbenW + p, -h, 0.0);
  glEnd();
end;

end.
